/*
 * Copyright (C) 2006 Jason Smith
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

/*!
 * @file util.c
 * @brief Implementation of the game's utility functions.
 */

#include "defs.h"
#include "util.h"
#include "log.h"

/////////////////////////////////////////////////////////////////////
int igems_Rand( int max )
{
	return (int)((float)max * rand() / (RAND_MAX));
}


/////////////////////////////////////////////////////////////////////
void igems_DrawLine( ttk_surface srf, int x1, int y1, int x2, int y2, int w, ttk_color col )
{
	int dw = (w-1)/2;

	if( x1 == x2 ) // vertical line
	{
		x1 -= dw;
		x2 = x1 + w;

		// adjust endpoints to lines meeting at the same point match up
		if( y1 < y2 )
		{
			y1 -= dw;
			y2 += dw;
		}
		else
		{
			y1 += dw;
			y2 -= dw;
		}
	}
	else if( y1 == y2 )
	{
		y1 -= dw;
		y2 = y1 + w;

		// adjust endpoints to lines meeting at the same point match up
		if( x1 < x2 )
		{
			x1 -= dw;
			x2 += dw;
		}
		else
		{
			x1 += dw;
			x2 -= dw;
		}
	}

	// draw the line
	ttk_fillrect( srf, x1, y1, x2, y2, col );
}

